<?php
/**
 * Created by PhpStorm.
 * User: matheussilva
 * Date: 27/04/2015
 * Time: 10:07
 */

namespace Folha\Logic\ObrigacaoLegal\RAIS\Entities;

use \Folha\Logic\ObrigacaoLegal\RAIS\FormataMagnetico;

class Tipo09Base extends FormataMagnetico
{
    protected $sequencial;    //06,
    protected $cnpj;          //14,
    protected $prefixoUlt;    //02,
    protected $tipoRegistro;  //01,
    protected $numRegTipo01;  //06,
    protected $numRegTipo02;  //06,
    protected $espacos;       //516

    /**
     * Cria a linha de magnético
     * @return string
     * @throws \Exception
     */
    public function getRow()
    {
        try {
            $row = "";
            $lengths = array(
                'cnpj'          => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' => 14),
                'prefixo_ult'   => array('FORMATO' => FormataMagnetico::FORMATO_MAG_STRING, 'TAMANHO' =>  2),
                'tipoRegistro'  => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  1),
                'numRegTipo01'  => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  6),
                'numRegTipo02'  => array('FORMATO' => FormataMagnetico::FORMATO_MAG_NUMERICO, 'TAMANHO' =>  6),
                'espacos'       => array('FORMATO' => FormataMagnetico::FORMATO_MAG_STRING, 'TAMANHO' => 516)
            );

            foreach($lengths as $name=>$length){
                $row.=$this->setData($this->$name,$length);
            }

            return $row;
        } catch (\Exception $e) {
            throw $e;
        }
    }
} 