<?php
/**
 *  Description of GepPautapadraoLogic
 *
 *  @package Logic.
 *
 *  @author  samuelleite
 */
class GepPautapadraoLogic {


    /**
     * Retorna dados de uma pauta padrao.
     *
     * @param integer $tipoReuniao Numero do tipo de reuniao.
     * @param integer $nrorg       Numero da organizacao.
     *
     * @return Ambigous <<type>, multitype:, mixed>|boolean
     */
    Public function consultaDadosPautaPadrao($tipoReuniao, $nrorg){
        $dados = GepPautapadraoEntity::consultaDadosPautaPadrao($tipoReuniao, $nrorg);
        return $dados;
    }


    /**       ok
     * Consulta o maior valor de ordenacao entre os textos da pauta padrao
     *
     * @param integer $nrorg       Numero da Organizacao.
     * @param integer $tiporeuniao Numero do tipo de reuniao
     *
     * @return multitype:|boolean
     */
    public static function proximoValorOrdenacaoPauta($nrorg, $tiporeuniao){
        $maior = GepPautapadraoEntity::consultaMaiorValorOrdenacaoPauta($nrorg, $tiporeuniao);

        if ($maior === null) {
            return 1;
        } else {
            return ++$maior;
        }
    }


    /**
     * Novo codigo NRPAUTAPADRAO.
     *
     * @param integer $nrorg Numero da organizacao.
     *
     * @return integer
     */
    public static function novoCodigoGepPautaPadrao($nrorg){
        $codigo = GepPautaPadraoEntity::retornaProxNumeroPautapadrao($nrorg);
        return $codigo;
    }


}
