var Dfe64000_IntegracaoCfopXmlComTipoDeOperacao_Controller = function(ScreenService, templateManager, ZhFilterPreferences, Dfe64000_IntegracaoCfopXmlComTipoDeOperacao_Service) {
    
    this.novoRelacionamento = function (widget) {
        widget.newRow();
        widget.currentRow.CDTIPOOPER = widget.appliedFilter.FILTER_ROW.CDTIPOOPER;
        widget.currentRow.NMTIPOOPER = widget.appliedFilter.FILTER_ROW.NMTIPOOPER;
    };
    
    this.novoRelacionamentoFilial = function (widget) {
        widget.newRow();
        widget.currentRow.CDTIPOOPER = widget.appliedFilter.FILTER_ROW.CDTIPOOPER;
        widget.currentRow.NMTIPOOPER = widget.appliedFilter.FILTER_ROW.NMTIPOOPER;
        widget.currentRow.CDFILIAL = widget.appliedFilter.FILTER_ROW.CDFILIAL;
        widget.currentRow.NMFILIAL = widget.appliedFilter.FILTER_ROW.NMFILIAL;
    };
    
    this.filterAfterApply = function (widget) {
        
        var stripeWidget = templateManager.container.getWidget("stripe");
        
        var campoFiltroTipoOper = stripeWidget.getField("NMTIPOOPERFILTRO");
        var campoFiltroUnidade = stripeWidget.getField("NMFILIALFILTRO");
        
        if (widget.appliedFilter === undefined) {
            campoFiltroTipoOper.setValue('');
            campoFiltroUnidade.setValue('');
            return;
        }
        
        var CDtipoOper = widget.appliedFilter.FILTER_ROW.CDTIPOOPER;
        var NMtipoOper = widget.appliedFilter.FILTER_ROW.NMTIPOOPER;
        
        campoFiltroTipoOper.setValue(CDtipoOper + " | " + NMtipoOper);
        
        if (widget.name === "Dfe64000_grid_filial") {
            var CDfilial   = widget.appliedFilter.FILTER_ROW.CDFILIAL;
            var NMfilial   = widget.appliedFilter.FILTER_ROW.NMFILIAL;

            campoFiltroUnidade.setValue(CDfilial + " | " + NMfilial);
        }
    };
    
    this.setDefaultFilialFilter = function(widget) {
        
        var popupFilter = Util.clone(widget.currentRow);
        
        Dfe64000_IntegracaoCfopXmlComTipoDeOperacao_Service.getFilialLogada().then( (filialLogada) =>  {
            var filial = filialLogada.dataset.filioper_lancamento_notafiscal[0];
            popupFilter.CDFILIAL = filial.CDFILIAL;
            popupFilter.NMFILIAL = filial.NMFILIAL;
            
            var geralWidget = templateManager.container.getWidget("Dfe64000_grid_geral");
            if (geralWidget.appliedFilter) {
                popupFilter.NMTIPOOPER = geralWidget.appliedFilter.FILTER_ROW.NMTIPOOPER;
                popupFilter.CDTIPOOPER = geralWidget.appliedFilter.FILTER_ROW.CDTIPOOPER;
            }
            
            ZhFilterPreferences.setOriginalFilter(widget.id, popupFilter);
            ZhFilterPreferences.openFilterWidget(widget, popupFilter);
        }); 
    };
    
    this.changeTabs = function (widget) {
        
        var stripeWidget = templateManager.container.getWidget("stripe");
        var campoFiltroUnidade = stripeWidget.getField("NMFILIALFILTRO");
        
        if (widget.name === "Dfe64000_grid_geral") {
            campoFiltroUnidade.isVisible = false;
        }
        else {
            campoFiltroUnidade.isVisible = true;
        }
        
        this.filterAfterApply(widget);
        
    };
    
    var requestError = function(error){
        var errorMessage = "Ocorreu um erro ao tentar realizar a operação.";
        if (error && error.data) {
          errorMessage = error.data.error;
        }
        if (error.type !== "click") {
            ScreenService.showMessage(errorMessage, "ERROR"); 
        }
    };
    
    this.salvar = function(widget){
        Dfe64000_IntegracaoCfopXmlComTipoDeOperacao_Service.salvar(widget);
    };
    
    this.deletar = function(widget){
        ScreenService.confirmMessage('Excluir Registro?', 'question', function (success) {
            Dfe64000_IntegracaoCfopXmlComTipoDeOperacao_Service.deletar(widget);}, requestError);
    };
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register("Dfe64000_IntegracaoCfopXmlComTipoDeOperacao_Controller", Dfe64000_IntegracaoCfopXmlComTipoDeOperacao_Controller);
});