var Dfe11000_LancamentoEntrada_Repositories = function(localStorageEngine, restEngine) {

    this.excluirNotaEntrada = function(filial, sequencialNota) {
        var row = {
            "CDFILIAL": filial,
            "NRLANCTONF": sequencialNota
        };
        return restEngine.post('df_entrada#/excluir_nota_entrada', {
            "requestType": "Row",
            "row": row
        });
    };

    this.salvaVencimento = function(vencimento) {
        return restEngine.post('df#/crud/contapagar/save', {
            "requestType": "Row",
            "row": vencimento
        });
    };

    this.excluiVencimento = function(vencimento){
        return restEngine.post('df#/crud/contapagar/remove', {
            "requestType": "Row",
            "row": vencimento
        });
    };

    this.calculaImpostoItemProduto = function(cabecalhoRow, lancamentoItemRow) {
        var rows = [cabecalhoRow, lancamentoItemRow];
        return restEngine.post('df#/calcula_imposto_item_produto', {
            "requestType": "DataSet",
            "dataset": rows
        });
    };

    this.realizaImportacaoItensNotaOrigem = function(cabecalhoRow) {
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": cabecalhoRow.CDFILIAL
            },
            {
                "name": "NRLANCTONF",
                "operator": "=",
                "value": cabecalhoRow.NRLANCTONF
            },
            {
                "name": "PKNOTAFISCORIG",
                "operator": "=",
                "value": (Array.isArray(cabecalhoRow.PKNOTAFISCORIG))? cabecalhoRow.PKNOTAFISCORIG : [cabecalhoRow.PKNOTAFISCORIG]
            }
        ];

        return restEngine.post('ger#/crud/itens_notas_origem_entrada', {
            "requestType": "FilterData",
            "filter": filter
        });
    };

    this.retornaParambloqnfafil = function(filial, entradaSaida, tipoOperac) {
        if (!filial)
            filial = 'FILIAL_LOGADA';

        var filter = [{
            "name": "CDFILIAL",
            "operator": "=",
            "value": filial
        }, {
            "name": "IDENTRSAIDOP",
            "operator": "=",
            "value": entradaSaida
        }, {
            "name": "CDTIPOOPER",
            "operator": "=",
            "value": tipoOperac
        }];

        return restEngine.post('df#/crud/parambloqnfafil', {
            "requestType": "FilterData",
            "filter": filter
        });
    };

    this.realizaImportacaoAf = function(cabecalhoRow) {
        return restEngine.post('df_entrada#/realiza_importacao_af', {
            "requestType": "Row",
            "row": cabecalhoRow
        });
    };

    this.buscaFornecedorBloqTpOperac = function(tipoOperacao, nrinsjurforn) {
        var filter = [
            {
                "name": "CDTIPOOPER",
                "operator": "=",
                "value": tipoOperacao
            },
            {
                "name": "P_NRINSJURFORN",
                "operator": "=",
                "value": nrinsjurforn
            },
            {
                "name": "IDLIBERATPOPFOR",
                "operator": "=",
                "value": 'N'
            }
        ];
        return restEngine.post('df_entrada#/parambloqnfafor_fornecedorparamsbloq', {
            "requestType": "FilterData",
            "filter": filter
        });
    };

    this.salvaImpostosNotaFiscal = function(impostos) {
        return restEngine.post('df_entrada#/salva_impostos_nota_fiscal', {
            "requestType": "DataSet",
            "dataset": impostos
        });
    };

    this.limpaTrabsLancamento = function(cdfilial, nrlanctonf) {
        return restEngine.post('df_entrada#/remove_trabs_lancamento_entrada', {
            "requestType": "Row",
            "row": {
                'CDFILIAL': cdfilial,
                'NRLANCTONF': nrlanctonf
            }
        });
    };

    this.validacaoSalvaCabecalhoEntrada = function(cabecalhoRow) {
        return restEngine.post('df_entrada#/validacao_salva_cabecalho_entrada', {
            "requestType": "Row",
            "row": cabecalhoRow
        });
    };
    
    this.geraSenhaLancRetroativo = function(lancRetroativoRow) {
        return restEngine.post('df_entrada#/gera_senha_lanc_retroativo', {
            "requestType": "Row",
            "row": lancRetroativoRow
        });
    };

    this.buscaNfChaveAcesso = function(nracessonfe) {
        var filter = [
            {
                'name': 'P_NRACESSONFE',
                'operator': '=',
                'value': nracessonfe
            }, {
                'name': 'P_IDENTRSAIDOP',
                'operator': '=',
                'value': 'E'
            }
        ];
        return restEngine.post('df_entrada#/intg_notafiscal_lancamento', {
            "requestType": "FilterData",
            "filter": filter
        });
    };
    
    this.buscaNfChaveAcessoPorCampos = function(params){
        var filter = [
            {
                'name': 'P_DTEMISSAO',
                'operator': '=',
                'value': params.DTEMISSAO
            },
            {
                'name': 'P_CDSERIEENTR',
                'operator': '=',
                'value': params.CDSERIEENTR
            },
            {
                'name': 'P_NRNOTAFISC',
                'operator': '=',
                'value': params.NRNOTAFISC
            },
            {
                'name': 'P_NRINSJURNF',
                'operator': '=',
                'value': params.NRINSJURNF
            }
        ];
        return restEngine.post('df_entrada#/intg_notafiscal_lancamento_campos', {
            "requestType": "FilterData",
            "filter": filter
        });
    };

    this.realizaImportacaoChaveAcesso = function(cabecalhoRow) {
        return restEngine.post('df_entrada#/realiza_importacao_chave_acesso', {
            "requestType": "Row",
            "row": cabecalhoRow
        });
    };

    this.realizaImportacaoAfChaveAcesso = function(cabecalhoRow) {
        return restEngine.post('df_entrada#/realiza_importacao_af_chave_acesso', {
            "requestType": "Row",
            "row": cabecalhoRow
        });
    };

    this.salvaRelacionamentoItensXml = function(relacionamentoRow) {
        return restEngine.post('df_entrada#/salva_relacionamento_itens_xml', {
            "requestType": "Row",
            "row": relacionamentoRow
        });
    };

    this.removerRelacionamentoItemXml = function(cdprodutoxml, cdforneced, cdfilial, cdproduto) {
        var row = {
            'CDPRODUTOXML' : cdprodutoxml,
            'CDFORNECED' : cdforneced,
            'CDFILIAL':cdfilial,
            'CDPRODUTO':cdproduto
        };

        return restEngine.post('df_entrada#/remove_relacionamento_item', {
            "requestType": "Row",
            "row": row
        });
    };

    this.salvaMultiItens = function(novosItens, itensAlterados, currentRowParentWidget) {
        var rows = [novosItens, itensAlterados, currentRowParentWidget];
        return restEngine.post('df_entrada#/salva_multi_itens_lancamento_entrada', {
            "requestType": "DataSet",
            "dataset": rows
        });
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Dfe11000_LancamentoEntrada_Repositories', Dfe11000_LancamentoEntrada_Repositories);
});
