var Dfe13000_espelho_de_notas_fiscais = function(General, templateManager, ZHPromise, ScreenService, ZhReports,ZhFilterPreferences, espelhoNF_Repository) {
    
    this.validacoesWidgetOnEnterOnce = function(espelhoNFArgs) {
        var espelhoNFWidget = espelhoNFArgs.owner;
        
        setDefaultFilialFilter(espelhoNFWidget).then(defaultFilter =>{
            ZhFilterPreferences.setOriginalFilter(espelhoNFWidget.id, defaultFilter);
            ZhFilterPreferences.openFilterWidget(espelhoNFWidget, defaultFilter);
            
        });
    };
    
    var getEspelhoWidget = function(){
        if(templateManager.container)
            return templateManager.container.getWidget("espelho_de_notas_fiscais");
    };
    
    this.getFieldFromFilterPopup = function(field , data){
        var EspelhoWidget = getEspelhoWidget();
        if(EspelhoWidget){
            var widgetAtiva = EspelhoWidget.getParent().getActiveWidget();
            if (data){
                if( widgetAtiva.name == 'zhFilterPreferencesSelectConditions'){
                    return data ==='end'? widgetAtiva.currentRow[field].end || null : widgetAtiva.currentRow[field].start || null ;
                }else{
                    return  data ==='end'? EspelhoWidget.appliedFilter.FILTER_ROW[field].end  || null :  EspelhoWidget.appliedFilter.FILTER_ROW[field].start  || null ;
                }
            }else {
                if(widgetAtiva.name == 'zhFilterPreferencesSelectConditions')
                return widgetAtiva.currentRow[field] || null;
            else
                return EspelhoWidget.appliedFilter.FILTER_ROW[field] || null;
            }
        }
    };

    var setDefaultFilialFilter = function(cabecalhoWidget) {
        var popupFilter = Util.clone(cabecalhoWidget.currentRow);
        var promise = ZHPromise.defer(); 
        
        General.callRestEngine( "df#/filial_lancamento_notafiscal", "FilterData", [{name: "CDFILIAL", operator: "=", value: "FILIAL_LOGADA"}]).then( (filialLogada) =>  {
            
            var filial = filialLogada.dataset.filial_lancamento_notafiscal[0];
            popupFilter.NMFILIAL = filial.NMFILIAL;
            popupFilter.CDFILIAL = filial.CDFILIAL;
            popupFilter.NMEMPRESA = filial.NMEMPRESA;
            popupFilter.CDEMPRESA = filial.CDEMPRESA;
            popupFilter.CDINSCESTA = filial.CDINSCESTA;
            popupFilter.DSINSCESTA = filial.CDINSCESTA;
            popupFilter.IDENTRSAIDOP = "E";

            popupFilter.DTEMISSAO = {start:  moment().subtract(1, 'months').format('DD/MM/YYYY'), end: moment().format("DD/MM/YYYY")};        
                    
            promise.resolve(popupFilter);
            
        }); 
  
        return promise;
    };

    this.getFieldValueFilter = function(fieldName, widgetName) {
        var container =  templateManager.container;
        if(container) {
            var filterWidget;
            var filterBforeApply = templateManager.container.getActiveWidget();
            if(filterBforeApply.name == 'zhFilterPreferencesSelectConditions')
              filterWidget = filterBforeApply;
            else {
                if(filterBforeApply.lastActiveWidget.name == 'zhFilterPreferencesSelectConditions'){
                    filterWidget = filterBforeApply.lastActiveWidget;
                    return filterWidget.currentRow[fieldName];
                }
                else{
                    var f = container.getWidget(widgetName);
                    if(f) {
                         filterWidget = container.getWidget(widgetName).appliedFilter;
                    }
                }
                    
               
            }
            
            if(filterWidget) {
                var valueField;
                if(filterBforeApply.name == 'zhFilterPreferencesSelectConditions')
                    valueField = filterWidget.currentRow[fieldName];
                else
                    valueField = filterWidget.FILTER_ROW[fieldName];
                    
                return valueField || null;
            }
            
               else return null;
        }
        else return null;
    };
    
    this.empresaOnChange = function(widget) {
        validaCamposInscricao(widget);
        var unidade = widget.getField("NMFILIAL");
        var empresa = widget.getField("NMEMPRESA");
        var inscrestad = widget.getField("CDINSCESTA");
        
        if(empresa.value() === ""){
            widget.currentRow.CDFILIAL = "";
            widget.currentRow.NMFILIAL = "";
            widget.currentRow.CDINSCESTA = "";
            
            unidade.readOnly = true;
            inscrestad.readOnly = true;
            
        } else {
            widget.currentRow.CDFILIAL = "";
            widget.currentRow.NMFILIAL = "";
            widget.currentRow.CDINSCESTA = "";
            
            unidade.readOnly = false ;
            inscrestad.readOnly = false ;
        }
        
        unidade.reload();
        inscrestad.reload();
    };
    
    var validaCamposInscricao = function(widget){
        var inscEsta = widget.getField("CDINSCESTA");
        inscEsta.readOnly = !widget.currentRow.NMEMPRESA;

        if(inscEsta.readOnly){
            widget.currentRow.DSINSCESTA = '';
        }
    };
    
    this.validaFiltro = function(args){
        var espelhoWidget = args.owner;
        var dataSourceFilter = espelhoWidget.dataSourceFilter;
        var camposData = ['IDENTRSAIDOP','CDEMPRESA','CDFILIAL', 'NMFILIAL', 'DTEMISSAO' , 'REPORTNAME'];
        var datasRemover = dataSourceFilter.filter(function(field){
            return camposData.indexOf(field.name) >= 0;
        });
        if(datasRemover && datasRemover.length >= 0){
            datasRemover.forEach(function(data){
                dataSourceFilter.splice(dataSourceFilter.indexOf(data), 1);
            });
        }
        
        args.owner.reload();
    };
    
    this.geraRelatorio = function(widget){
        var rows = widget.getCheckedRows();
        //var REPORTNAME  = widget.appliedFilter.FILTER_ROW.REPORTNAME;
        if(rows.length > 0 ){
            validaDados(rows).then((NFsemProdutos) => {
                if (NFsemProdutos.length !== 0){
                        mensagemNaoDadosListado(NFsemProdutos);
                }else {
                    rows[0].REPORTNAME = "DFE13000";
                    espelhoNF_Repository.geraRelatorio(rows).then(function(birtURL){
                    window.open(birtURL.dataset.URL[0]);
                    }, function(error) {
                    ScreenService.showMessage(error.data.error);
                });
                } 
            });

        }else {
            ScreenService.showMessage("Selecione uma Nota Fiscal");
        }  
    };
    
    this.openFilter = function(args) {

        ZhFilterPreferences.openFilterWidget(args.owner, true).then(response => {
            var filter = templateManager.container.getActiveWidget();
            var clearFilter = filter.actions.filter(action => action.name === 'clear')[0];
            var confirmFilter = filter.actions.filter(action => action.name === 'never')[0];
            
            clearFilter.shortcutKey = 'ctrl+backspace';
            clearFilter.tooltip = 'Limpar Filtro (CTRL + Backspace)';
            
            confirmFilter.shortcutKey = 'ctrl + enter';

            this.validacoesWidgetOnEnterOnce(args);
            
            filter.reload();
            
        });
    };

    this.toggleEntradaSaida = function() {
        var widget = templateManager.container.getActiveWidget();
        var row =  widget.currentRow;

        if(row.IDENTRSAIDOP == 'E') {
            getEspelhoWidget().getField('DTENTRSAID').label = "Data de Entrada";
            
            getEspelhoWidget().getField('NRINSJURNF').showOnList = true;
            getEspelhoWidget().getField('NRINSJURNF').isVisible = true;

            getEspelhoWidget().getField('NMRAZAOORIGENTR').showOnList = true;
            getEspelhoWidget().getField('NMRAZAOORIGENTR').isVisible = true;

            getEspelhoWidget().getField('NMRAZAOORIGSAID').showOnList = false;
            getEspelhoWidget().getField('NMRAZAOORIGSAID').isVisible = false;

            getEspelhoWidget().getField('NMRAZAODESTSAID').showOnList = false;
            getEspelhoWidget().getField('NMRAZAODESTSAID').isVisible = false;

        } else {
            getEspelhoWidget().getField('DTENTRSAID').label = "Data de Saída";

            getEspelhoWidget().getField('NRINSJURNF').showOnList = false;
            getEspelhoWidget().getField('NRINSJURNF').isVisible = false;

            getEspelhoWidget().getField('NMRAZAOORIGENTR').showOnList = false;
            getEspelhoWidget().getField('NMRAZAOORIGENTR').isVisible = false;

            getEspelhoWidget().getField('NMRAZAOORIGSAID').showOnList = true;
            getEspelhoWidget().getField('NMRAZAOORIGSAID').isVisible = true;

            getEspelhoWidget().getField('NMRAZAODESTSAID').showOnList = true;
            getEspelhoWidget().getField('NMRAZAODESTSAID').isVisible = true;

        }
        
        getEspelhoWidget().reload();

    };
    
    var validaDados =  function(rows) {
        var promise = ZHPromise.defer(); 
        let NFsemProdutos = [];
        var rowsProcessadas = 0;
        rows.forEach((row) => {
            var filter =  [{name: "CDFILIAL",operator: "=",value: row.CDFILIAL},{name: "NRLANCTONF",operator: "=",value: row.NRLANCTONF}];
            General.callRestEngine( "df_relatorios#/crud/qryCDItemProduto", "FilterData", filter).then(function(itemProduto){
                 if (itemProduto.dataset.qryCDItemProduto.length == 0) {
                    NFsemProdutos.push(row.NRLANCTONF);
                 }
                 rowsProcessadas++;
                 if(rowsProcessadas == rows.length){ 
                     promise.resolve(NFsemProdutos);
                     
                 }
            }); 
        });

            
        return promise;
  
    };
    
    var mensagemNaoDadosListado =  function(rows) {
        let notas =" ";
        rows.forEach(function(row){
            notas += `, ${row}`;
        });
        
        ScreenService.showMessage("Não há dados listados para a(s) nota(s) com o(s) seguinte(s) número(s) de lançamento(s): " + notas.substr(2) );
    };
    
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register("Dfe13000_espelho_de_notas_fiscais", Dfe13000_espelho_de_notas_fiscais);
});